function [Centroids, Labels, numberOfParticles] = FindCentroids(InputImage, Threshold)

    mask = im2bw(InputImage, Threshold);
    mask = imclearborder(mask);                                   % eliminate particles touching edges
    mask = imdilate(mask, strel('disk', 2));                      % open up the mask a little
    Labels = bwlabel(mask);

    numberOfParticles = max(max(Labels));

    particleInformation = regionprops(Labels, InputImage, 'WeightedCentroid');
    
    Centroids = vertcat( particleInformation(:).WeightedCentroid );

end